# Terminal.Gui v1 - Cross Platform Terminal UI toolkit for .NET

**These are the v1 API docs**. The v2 API docs are [here](https://gui-cs.github.io/Terminal.GuiV2Docs/).

A toolkit for building rich console apps for .NET, .NET Core, and Mono that works on Windows, the Mac, and Linux/Unix.

![Sample](images/sample.gif)

* [Terminal.Gui Project on GitHub](https://github.com/gui-cs/Terminal.Gui)

## Terminal.Gui API Documentation

* [API Reference](~/api/Terminal.Gui.yml)
* [Views and controls built into the Terminal.Gui library](~/docs/views.md)
* [Terminal.Gui API Overview](~/docs/overview.md)
* [Keyboard Event Processing](~/docs/keyboard.md)
* [Event Processing and the Application Main Loop](~/docs/mainloop.md)
* [Cross-platform Driver Model](~/docs/drivers.md)
* [TableView Deep Dive](~/docs/tableview.md)
* [TreeView Deep Dive](~/docs/treeview.md)

## UI Catalog

UI Catalog is a comprehensive sample library for Terminal.Gui. It provides a simple UI for adding to the catalog of scenarios.

* [UI Catalog API Reference](~/api/UICatalog/UICatalog.yml)
* [UI Catalog Source](https://github.com/gui-cs/Terminal.Gui/tree/master/UICatalog)
